Overview

The Zenkraft API is designed to be as standardized across all carriers as possible. The basic structure of each request is the same, with carrier-specific fields typically nested within special services.



OpenAPI 3 Specification

This API is also available in a machine-readable form as a OpenAPI 3 document

  • Basic authentication using a JWT token

  • RESTful using HTTP Verbs

  • JSON requests and responses


Test Tracking Numbers

The tracking numbers can be used below for testing purposes:

  • TEST100000001 - information sent to carrier
  • TEST100000002 - picked up
  • TEST100000003 - in transit
  • TEST100000004 - out for delivery
  • TEST100000005 - delivered
  • TEST100000006 - exception


Authentication

The Zenkraft API uses a bearer token to authenticate. If you do not have one, please contact support.

zkkey : your_api_key
Base URL
https://api.zenkraft.com

/shippingaccount POST

The /shippingaccount endpoint enables you to use your carrier account credentials to create a Shipping Acccount ID in the Zenkraft system. This is used for all future API calls listed below.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipping_account object required
auth object Carrier credentials which are specific to each carrier {'account_number': 'XXXXXXXX', 'meter_number': 'XXXXXXXX', 'key': 'XXXXXXXXXXXXXXXXXXXXXXXX', 'password': 'XXXXXXXXXXXXXXXXXXXXXXXX'}
billing_address object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF NP HK TL NE US US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
carrier string Carrier slug required fedex
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
defaults object
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK VND INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL MMK PKR TRY XCD NGN SLL HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN MYR IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT SRD AFN THB COP MDL GYD GIP DOP CUC HUF UAH MWK CLP
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
label_type string Label Type PDF
packaging_type string Packaging Type your_packaging
service string Service Type domestic_standard
weight_units string Weight units of the packages, pounds or kilograms KG LB LB
location_id string Location ID 0d349ee54a8c4d0dbc61b1a3ac1ab1f4
name string Account name My FedEx test account
parent_shipping_account string Shipping account key to link this account to. This is useful when you want to create a sub-account
test boolean If you specify test flag and omit `auth` key, we'll try to create a shipping account with our test credentials for the carrier/country combination specified


Successful Response
Field Possible Values Example
shipping_account object
auth object Carrier credentials which are specific to each carrier {'account_number': 'XXXXXXXX', 'meter_number': 'XXXXXXXX', 'key': 'XXXXXXXXXXXXXXXXXXXXXXXX', 'password': 'XXXXXXXXXXXXXXXXXXXXXXXX'}
carrier string Carrier slug required fedex
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
defaults object required
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK VND INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL MMK PKR TRY XCD NGN SLL HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN MYR IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT SRD AFN THB COP MDL GYD GIP DOP CUC HUF UAH MWK CLP
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
label_type string Label Type PDF
packaging_type string Packaging Type your_packaging
service string Service Type domestic_standard
weight_units string Weight units of the packages, pounds or kilograms KG LB LB
id string Shipping account number required 5190163571408896
location_id string Location ID 0d349ee54a8c4d0dbc61b1a3ac1ab1f4
name string Account name My FedEx test account
parent_shipping_account string Shipping account key to link this account to. This is useful when you want to create a sub-account
test boolean If you specify test flag and omit `auth` key, we'll try to create a shipping account with our test credentials for the carrier/country combination specified


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key master_test_shipping_account_not_found missing_api_key schema_validation_error shipping_account_not_found shipping_account_wrong_carrier schema_field_required master_test_shipping_account_not_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required Master shipping account for fedex in US does not exist
Example Request / Response
{
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}
                curl --request POST \
--url https://api.zenkraft.com/shippingaccount \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipping_account": {
        "name": "Test",
        "carrier": "fedex",
        "country": "US",
        "test" : true
    }
}
url = "https://api.zenkraft.com/shippingaccount"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
    "shipping_account": {
        "name": "My FedEx test account",
        "carrier": "fedex",
        "country": "US",
        
        "test": false,
        "id": "567293923024"
    }
}

/rate POST

The rating endpoint is used to return estimated costs & time in transit data from the carrier. Zenkraft normalize this data across carriers providing a standardized date and cost format from the carriers (where the functionality is supported).

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipment object Definition of the shipment payload required
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL MMK PKR TRY XCD NGN SLL HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN MYR IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT SRD AFN THB COP MDL GYD GIP DOP CUC HUF VND UAH MWK CLP
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
packaging string the packaging type required your_packaging your_packaging
recipient object required
city string the city of the recipient Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU NP HK TL NE WF US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
sender object required
city string the city of the recipient Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU NP HK TL NE WF US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string if you specify the service type, you'll get rates only for this service fedex_ground
ship_date string shipping date in the ISO format 2021-06-07
shipping_account string Shipping account number required 5190163571408896
special_services array [saturday_delivery ]
test boolean calls created with test = true will be directed to the carrier test servers
type string outbound or return shipments outbound return outbound
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
rates array
currency string USD AED AFN ALL AMD ANG AOA ARS AUD AWG AZN BAM BBD BDT BGN BHD BIF BMD BND BOB BRL BSD BTN BWP BYN BZD CAD CDF CHF CLP CNY COP CRC CUC CUP CVE CZK DJF DKK DOP DZD EGP ERN ETB EUR FJD FKP GBP GEL GGP GHS GIP GMD GNF GTQ GYD HKD HNL HRK HTG HUF IDR ILS IMP INR IQD IRR ISK JEP JMD JOD JPY KES KGS KHR KMF KPW KRW KWD KYD KZT LAK LBP LKR LRD LSL LYD MAD MDL MGA MKD MMK MNT MOP MRU MUR MVR MWK MXN MYR MZN NAD NGN NIO NOK NPR NZD OMR PAB PEN PGK PHP PKR PLN PYG QAR RON RSD RUB RWF SAR SBD SCR SDG SEK SGD SHP SLL SOS SPL SRD STN SVC SYP SZL THB TJS TMT TND TOP TRY TTD TVD TWD TZS UAH UGX UYU UZS VEF VND VUV WST XAF XCD XDR XOF XPF YER ZAR ZMW ZWD
delivery_day string Day of the week of the delivery. This field is optional depending on the carrier Mon
estimated_date string Number of days to ship. This field is optional depending on the carrier 2021-06-04
service_name string carrier supplied name of this service FedEx Freight
service_type string service slug which can be used when selecting a service in /ship fedex_ground
total_cost string total estimated price for this shipment 192.16
transit_days integer Number of days to ship. This field is optional depending on the carrier 3


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required ship_date_past carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/rate \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
url = "https://api.zenkraft.com/rate"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "rates": [
    {
      "currency": "USD",
      "service_name": "Express",
      "service_type": "economy",
      "total_cost": "192.16",
      "estimated_date": "2026-11-22",
      "delivery_day": "Mon",
      
      "transit_days": 3
    }
  ]
}

/ship POST

The shipping endpoint is used to book shipments with . It will return a shipping label and tracking number in the response.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
shipment object Definition of the shipment payload required
combined_labels boolean Optional flag indicating whether package labels should be combined
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL MMK PKR TRY XCD NGN SLL HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN MYR IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT SRD AFN THB COP MDL GYD GIP DOP CUC HUF VND UAH MWK CLP
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
documents array
document string document content
document_type string file format of the document pdf
id string uploaded document ID
include_base64_label boolean If this is enabled, base64 label is returned
label_size string the shipping labels size 4x6
label_type string the label format of the shipping labels required JPG GIF PNG ZPL PDF PDF
notifications array
type string type of the notification needed email sms email
value string value of the notification notification1@example.com
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
packaging string the packaging type required your_packaging your_packaging
recipient object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
references array
type string type of reference customer_reference
value string value of the reference ABC-000123
sender object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type required fedex_ground
ship_date string shipping date in the ISO format 2021-06-07
shipping_account string Shipping account number required 5190163571408896
special_services array [saturday_delivery ]
test boolean calls created with test = true will be directed to the carrier test servers
type string outbound or return shipments outbound return outbound
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Most important parts of the response:
  • tracking_number which can be used to track the shipments in the track endpoint
  • label for each package which needs to be printed and attached to the shipment
Field Possible Values Example
shipment object
context object this object can contain custom data returned by the carrier
costs object Additional information about packages
base_charge number gross amount 100
discounts number the cost of discounts applied 0
net_charge number net amount 80
surcharges number additional fees 0
taxes number the cost of taxes 20
id string shipment ID 1f02d12868a54ed88b6cb4dafaad325d
packages array
height number height of the package according to units specified under dim_units 5
label string base64 label if you specify include_base64_label flag in your request or an URL to the generated label
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
tracking_number string Tracking number of shipment 567293923024
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
shipping_documents object Additional information about packages
description string description of this customs item required Commercial Invoice
document string base64 document contents required
document_type string file format of the document required PDF
tracking_number string Tracking number of shipment 567293923024


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method invalid_phone_number missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found carrier_shipment_generation_failed shipping_account_wrong_carrier schema_field_required ship_date_past carrier_label_generation_failed carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/ship \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "shipment": {
        "carrier": "fedex",
        "currency": "GBP",
        "debug": true,
        "dim_units": "CM",
        "include_base64_label": true,
        "label_type": "PDF",
        "packages": [
            {
                "height": 1,
                "length": 1,
                "value": 1,
                "weight": 1,
                "width": 1
            }
        ],
        "packaging": "your_packaging",
        "recipient": {
            "city": "london",
            "company": "Zenkraft User",
            "country": "GB",
            "email": "testexample@gmail.com",
            "name": "Test User",
            "phone": "01222 555 555",
            "postal_code": "EC1R 4UG",
            "state": "",
            "street1": "1 Hardwick Street"
        },
        "sender": {
            "city": "Bath",
            "company": "TestCompany",
            "country": "GB",
            "email": "uk@testing.com",
            "name": "TestCompany Name",
            "phone": "",
            "postal_code": "EC2R 6PJ",
            "street1": "30 Moorgate"
        },
        "service": "economy",
        "ship_date": "2026-11-22",
        "shipping_account": "811195730",
        "test": true,
        "type": "outbound",
        "weight_units": "KG"
    }
}
url = "https://api.zenkraft.com/ship"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "shipment": {
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "ship_date": "2026-11-22",
    "type": "outbound",
    "combined_labels": false,
    "service": "economy",
    "special_services": [
      "saturday_delivery"
    ],
    "packaging": "your_packaging",
    "dim_units": "IN",
    "weight_units": "LB",
    "currency": "USD",
    "sender": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "recipient": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "packages": [
      {
        "weight": 4.2,
        "value": 25,
        "length": 11,
        "width": 8.5,
        "height": 5,
        "tracking_number": "567293923024",
        "label": "string"
      }
    ],
    "label_type": "PDF",
    "include_base64_label": false,
    "references": [
      {
        "type": "customer_reference",
        "value": "ABC-000123"
      }
    ],
    "notifications": [
      {
        "type": "email",
        "value": "notification1@example.com"
      }
    ],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    },
    "id": "1f02d12868a54ed88b6cb4dafaad325d",
    "tracking_number": "567293923024",
    "shipping_documents": [{
      "description": "Commercial Invoice",
      "document_type": "PDF",
      "document": "string"
    }],
    "context": {}
  }
}

/ship GET

This endpoint allows you to retrieve previously created shipments

GET Request Parameters
Field Possible Values Example
shipment_id object ID of the previously created shipment returned from POST on /ship required


Successful Response
Field Possible Values Example
shipment object
carrier string the carrier name fedex
created string when was this object created 2021-06-02T07:22:43.000
id string shipment ID 1f02d12868a54ed88b6cb4dafaad325d
label string base64 label
label_type string the label format of the shipping labels JPG GIF PNG ZPL PDF PDF
shipping_account string Shipping account number 5190163571408896
status string Standardized shipment status success pending success
tracking_number string Tracking number of shipment 567293923024
updated string when was this object updated 2021-06-02T13:10:02.000


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required carrier_no_shipment_found carrier_label_generation_failed carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required DHL Global Forwarding API: Your shipment was rejected due to an unpaid invoice on your previous shipment. Contact DHL support to resolve the issue.
Example Request / Response
https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7
                curl --request GET \
--url https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7 \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = None
url = "https://api.zenkraft.com/ship/b87ff34556ec4dba9e724963216d2dd7"

response = requests.request(url=url, method='GET', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "shipment": {
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "ship_date": "2026-11-22",
    "type": "outbound",
    "combined_labels": false,
    "service": "economy",
    "special_services": [
      "saturday_delivery"
    ],
    "packaging": "your_packaging",
    "dim_units": "IN",
    "weight_units": "LB",
    "currency": "USD",
    "sender": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "recipient": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US"
    },
    "packages": [
      {
        "weight": 4.2,
        "value": 25,
        "length": 11,
        "width": 8.5,
        "height": 5,
        "tracking_number": "567293923024",
        "label": "string"
      }
    ],
    "label_type": "PDF",
    "include_base64_label": false,
    "references": [
      {
        "type": "customer_reference",
        "value": "ABC-000123"
      }
    ],
    "notifications": [
      {
        "type": "email",
        "value": "notification1@example.com"
      }
    ],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    },
    "id": "1f02d12868a54ed88b6cb4dafaad325d",
    "tracking_number": "567293923024",
    "shipping_documents": [{
      "description": "Commercial Invoice",
      "document_type": "PDF",
      "document": "string"
    }],
    "context": {}
  }
}

/track POST

The track endpoint is used to track shipment status as it's being delivered.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
track object required
checkpoints boolean whether to include checkpoint events in the response or not
debug boolean calls with debug=true will be logged
locale string language used in the checkpoint response. Not all carriers support different languages ar_EG zh_Hans_HK el_GR az_Cyrl_AZ teo_KE ur_PK ka_GE ta_LK en_TT id_ID bg_BG chr_US en_MU fr_CH es_US ar_JO en_GU fr_MG hy_AM fa_AF gu_IN pl_PL zh_Hant_TW es_SV rof_TZ ko_KR lv_LV de_DE en_CA to_TO it_CH ha_Latn ar_AE fr_NE so_KE az_Latn_AZ nl_BE en_VI pt_PT om_ET en_PH lag_TZ ar_TN ha_Latn_GH en_ZA ro_RO as_IN sr_Cyrl fr_MF es_BO es_CL teo_UG en_IL bo_CN ti_ET ti_ER nd_ZW ar_YE it_IT ar_SA sw_TZ ru_MD jmc_TZ bn_BD de_BE bez_TZ es_DO ig_NG ml_IN de_AT es_AR kk_Cyrl_KZ uz_Arab_AF es_CO shi_Latn_MA bm_ML fr_BE ha_Latn_NE fa_IR ebu_KE de_LU mr_IN kea_CV sr_Cyrl_BA tzm_Latn_MA en_IN pa_Arab vi_VN te_IN sk_SK shi_Tfng_MA ses_ML fr_GQ az_Latn uz_Latn_UZ ki_KE en_MP fr_LU mk_MK fr_TD shi_Latn en_SG hr_HR en_IE fr_KM nb_NO pa_Guru_IN es_MX uz_Arab en_BE is_IS fr_BJ ar_OM fr_RE pa_Guru zh_Hant_HK ar_KW nyn_UG en_US luo_KE ar_BH uz_Latn en_NZ en_GB sg_CF eu_ES ru_RU saq_KE fr_CA sr_Cyrl_ME es_CR shi_Tfng es_VE en_BZ fr_MC tr_TR kw_GB fr_CG so_ET zh_Hans en_BW fr_DJ seh_MZ nn_NO kab_DZ khq_ML pt_GW kam_KE es_ES pt_MZ en_NA fr_CI fr_CF ca_ES zh_Hant_MO si_LK luy_KE mg_MG rwk_TZ az_Cyrl en_HK ja_JP ms_BN sn_ZW sr_Cyrl_RS zh_Hans_CN sw_KE en_UM fr_BL bem_ZM ar_QA fr_SN kk_Cyrl ne_NP sl_SI es_GT en_ZW ar_SD ee_GH cs_CZ es_PE ha_Latn_NG rm_CH sq_AL lg_UG naq_NA da_DK af_NA kok_IN zh_Hans_MO vun_TZ ak_GH ar_LY kde_TZ es_GQ rw_RW tzm_Latn af_ZA fr_BI fr_GN de_LI hu_HU be_BY es_EC ro_MD ar_DZ am_ET th_TH fr_CM fr_FR mer_KE yue_Hant_HK zh_Hant fr_MQ ar_LB el_CY fo_FO es_UY fr_ML fr_BF kn_IN ms_MY ff_SN sr_Latn_BA es_HN pt_BR et_EE cy_GB en_PK zh_Hans_SG or_IN bs_BA ar_MA bo_IN sr_Latn_ME en_MT kln_KE dav_KE ee_TG sr_Latn_RS my_MM es_PA hi_IN bn_IN sr_Latn es_PR cgg_UG fr_GP haw_US ar_IQ gv_GB sv_SE fi_FI ar_SY pa_Arab_PK de_CH nl_NL km_KH lt_LT fr_GA mas_KE so_SO ii_CN uz_Cyrl_UZ asa_TZ sv_FI mt_MT en_MH ne_IN ps_AF yo_NG es_PY en_JM fr_CD es_419 fil_PH guz_KE he_IL kl_GL es_NI ur_IN ga_IE gl_ES mas_TZ zu_ZA om_KE ru_UA so_DJ uz_Cyrl en_AU ta_IN mfe_MU en_AS fr_RW xog_UG fr_TG uk_UA gsw_CH en_US
refresh boolean whether to force calling live carrier API. By default, we might return a fresh result from the cache
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
tracking_number string Tracking number of shipment required 567293923024
webhooks boolean whether to allow webhook functionality for this shipment


Successful Response
Field Possible Values Example
carrier string the carrier name fedex
checkpoints array
description string Delivered to a mailbox
status string the most recent important status description Delivered to a mailbox
time string 2021-06-07T10:46:07.000+1000
tracking_stage string the most recent important status standardized shipment stage CREATION_PENDING CREATED PICKED_UP IN_TRANSIT OUT_FOR_DELIVERY DRIVER_ASSIGNED CHECKED_IN DELIVERED SHIPMENT_VOIDED EXCEPTION DELIVERED
delivered boolean whether the shipment was successfully delivered
delivery_date string delivery date of this shipment 2021-06-07T00:00:00.000Z
estimated_delivery string estimated delivery date of this shipment 2021-06-07T00:00:00.000Z
locale string locale used in the checkpoint response. Not all carriers support different languages ar_EG zh_Hans_HK el_GR az_Cyrl_AZ teo_KE ur_PK ka_GE ta_LK en_TT id_ID bg_BG chr_US en_MU fr_CH es_US ar_JO en_GU fr_MG hy_AM fa_AF gu_IN pl_PL zh_Hant_TW es_SV rof_TZ ko_KR lv_LV de_DE en_CA to_TO it_CH ha_Latn ar_AE fr_NE so_KE az_Latn_AZ nl_BE en_VI pt_PT om_ET en_PH lag_TZ ar_TN ha_Latn_GH en_ZA ro_RO as_IN sr_Cyrl fr_MF es_BO es_CL teo_UG en_IL bo_CN ti_ET ti_ER nd_ZW ar_YE it_IT ar_SA sw_TZ ru_MD jmc_TZ bn_BD de_BE bez_TZ es_DO ig_NG ml_IN de_AT es_AR kk_Cyrl_KZ uz_Arab_AF es_CO shi_Latn_MA bm_ML fr_BE ha_Latn_NE fa_IR ebu_KE de_LU mr_IN kea_CV sr_Cyrl_BA tzm_Latn_MA en_IN pa_Arab vi_VN te_IN sk_SK shi_Tfng_MA ses_ML fr_GQ az_Latn uz_Latn_UZ ki_KE en_MP fr_LU mk_MK fr_TD shi_Latn en_SG hr_HR en_IE fr_KM nb_NO pa_Guru_IN es_MX uz_Arab en_BE is_IS fr_BJ ar_OM fr_RE pa_Guru zh_Hant_HK ar_KW nyn_UG en_US luo_KE ar_BH uz_Latn en_NZ en_GB sg_CF eu_ES ru_RU saq_KE fr_CA sr_Cyrl_ME es_CR shi_Tfng es_VE en_BZ fr_MC tr_TR kw_GB fr_CG so_ET zh_Hans en_BW fr_DJ seh_MZ nn_NO kab_DZ khq_ML pt_GW kam_KE es_ES pt_MZ en_NA fr_CI fr_CF ca_ES zh_Hant_MO si_LK luy_KE mg_MG rwk_TZ az_Cyrl en_HK ja_JP ms_BN sn_ZW sr_Cyrl_RS zh_Hans_CN sw_KE en_UM fr_BL bem_ZM ar_QA fr_SN kk_Cyrl ne_NP sl_SI es_GT en_ZW ar_SD ee_GH cs_CZ es_PE ha_Latn_NG rm_CH sq_AL lg_UG naq_NA da_DK af_NA kok_IN zh_Hans_MO vun_TZ ak_GH ar_LY kde_TZ es_GQ rw_RW tzm_Latn af_ZA fr_BI fr_GN de_LI hu_HU be_BY es_EC ro_MD ar_DZ am_ET th_TH fr_CM fr_FR mer_KE yue_Hant_HK zh_Hant fr_MQ ar_LB el_CY fo_FO es_UY fr_ML fr_BF kn_IN ms_MY ff_SN sr_Latn_BA es_HN pt_BR et_EE cy_GB en_PK zh_Hans_SG or_IN bs_BA ar_MA bo_IN sr_Latn_ME en_MT kln_KE dav_KE ee_TG sr_Latn_RS my_MM es_PA hi_IN bn_IN sr_Latn es_PR cgg_UG fr_GP haw_US ar_IQ gv_GB sv_SE fi_FI ar_SY pa_Arab_PK de_CH nl_NL km_KH lt_LT fr_GA mas_KE so_SO ii_CN uz_Cyrl_UZ yo_NG asa_TZ sv_FI mt_MT en_MH ne_IN ps_AF es_PY en_JM fr_CD es_419 fil_PH guz_KE he_IL kl_GL es_NI ur_IN ga_IE gl_ES mas_TZ zu_ZA om_KE ru_UA so_DJ uz_Cyrl en_AU ta_IN mfe_MU en_AS fr_RW xog_UG fr_TG uk_UA gsw_CH en_US
status string the most recent important status description Delivered to a mailbox
tracking_number string Tracking number of shipment 567293923024
tracking_stage string the most recent important status standardized shipment stage CREATION_PENDING CREATED PICKED_UP IN_TRANSIT OUT_FOR_DELIVERY DRIVER_ASSIGNED CHECKED_IN DELIVERED SHIPMENT_VOIDED EXCEPTION DELIVERED


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required carrier_no_shipment_found carrier_no_shipment_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: No shipment found with tracking number: 567293923024
Example Request / Response
{
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/track \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
}
url = "https://api.zenkraft.com/track"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "carrier": "fedex",
  "delivered": true,
  "estimated_delivery": "2021-06-07T00:00:00.000Z",
  "delivery_date": "2021-06-07T00:00:00.000Z",
  "tracking_number": "567293923024",
  "status": "Delivered to a mailbox",
  "tracking_stage": "DELIVERED",
  "checkpoints": [
    {
      "description": "Delivered to a mailbox",
      "status": "Delivered to a mailbox",
      "tracking_stage": "DELIVERED",
      "time": "2021-06-07T10:46:07.000+1000"
    }
  ]
}

Batch tracking

You can pass several track objects into your API request to get results.
Request and response details are the same and can be checked here.

Example Request / Response
[
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]
                curl --request POST \
--url https://api.zenkraft.com/track \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '[
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = [
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  },
  {
    "track": {
      "test":false,
      "carrier": "fedex",
      "shipping_account": 00000000000000,
      "tracking_number": "1Z7881280399212000"
    }
  }
]
url = "https://api.zenkraft.com/track"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
[
  {
    "carrier": "fedex",
    "delivered": true,
    "estimated_delivery": "2021-06-07T00:00:00.000Z",
    "delivery_date": "2021-06-07T00:00:00.000Z",
    "tracking_number": "567293923024",
    "status": "Delivered to a mailbox",
    "tracking_stage": "DELIVERED",
    "checkpoints": [
      {
        "description": "Delivered to a mailbox",
        "status": "Delivered to a mailbox",
        "tracking_stage": "DELIVERED",
        "time": "2021-06-07T10:46:07.000+1000"
      }
    ]
  },
  {
    "carrier": "fedex",
    "delivered": true,
    "estimated_delivery": "2021-06-07T00:00:00.000Z",
    "delivery_date": "2021-06-07T00:00:00.000Z",
    "tracking_number": "567293923024",
    "status": "Delivered to a mailbox",
    "tracking_stage": "DELIVERED",
    "checkpoints": [
      {
        "description": "Delivered to a mailbox",
        "status": "Delivered to a mailbox",
        "tracking_stage": "DELIVERED",
        "time": "2021-06-07T10:46:07.000+1000"
      }
    ]
  }
]

/cancel POST

The cancel endpoint allows you to cancel shipments with the carrier.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
cancel object required
checkpoints boolean whether to include checkpoint events in the response or not
debug boolean calls with debug=true will be logged
locale string language used in the checkpoint response. Not all carriers support different languages ar_EG zh_Hans_HK el_GR az_Cyrl_AZ teo_KE ur_PK ka_GE ta_LK en_TT id_ID bg_BG chr_US en_MU fr_CH es_US ar_JO en_GU fr_MG hy_AM fa_AF gu_IN pl_PL zh_Hant_TW es_SV rof_TZ ko_KR lv_LV de_DE en_CA to_TO it_CH ha_Latn ar_AE fr_NE so_KE az_Latn_AZ nl_BE en_VI pt_PT om_ET en_PH lag_TZ ar_TN ha_Latn_GH en_ZA ro_RO as_IN sr_Cyrl fr_MF es_BO es_CL teo_UG en_IL bo_CN ti_ET ti_ER nd_ZW ar_YE it_IT ar_SA sw_TZ ru_MD jmc_TZ bn_BD de_BE bez_TZ es_DO ig_NG ml_IN de_AT es_AR kk_Cyrl_KZ uz_Arab_AF es_CO shi_Latn_MA fr_BE bm_ML ha_Latn_NE fa_IR ebu_KE de_LU mr_IN kea_CV sr_Cyrl_BA tzm_Latn_MA en_IN pa_Arab vi_VN te_IN sk_SK shi_Tfng_MA ses_ML fr_GQ az_Latn uz_Latn_UZ ki_KE en_MP fr_LU mk_MK fr_TD shi_Latn en_SG hr_HR en_IE fr_KM nb_NO pa_Guru_IN es_MX uz_Arab en_BE is_IS fr_BJ ar_OM fr_RE pa_Guru zh_Hant_HK ar_KW nyn_UG en_US luo_KE ar_BH uz_Latn en_NZ en_GB sg_CF eu_ES ru_RU saq_KE fr_CA sr_Cyrl_ME es_CR shi_Tfng es_VE en_BZ fr_MC tr_TR kw_GB fr_CG so_ET zh_Hans en_BW fr_DJ seh_MZ nn_NO kab_DZ khq_ML pt_GW kam_KE es_ES fr_RW pt_MZ en_NA fr_CI fr_CF ca_ES zh_Hant_MO si_LK luy_KE mg_MG rwk_TZ az_Cyrl en_HK ja_JP ms_BN sn_ZW sr_Cyrl_RS zh_Hans_CN sw_KE en_UM fr_BL bem_ZM ar_QA fr_SN kk_Cyrl ne_NP sl_SI es_GT en_ZW ar_SD ee_GH cs_CZ es_PE ha_Latn_NG rm_CH sq_AL naq_NA da_DK af_NA kok_IN zh_Hans_MO vun_TZ ak_GH ar_LY kde_TZ es_GQ rw_RW tzm_Latn af_ZA fr_BI fr_GN de_LI hu_HU be_BY es_EC ro_MD ar_DZ am_ET th_TH fr_CM fr_FR mer_KE yue_Hant_HK zh_Hant fr_MQ ar_LB el_CY fo_FO es_UY fr_ML fr_BF kn_IN ms_MY ff_SN sr_Latn_BA es_HN pt_BR et_EE cy_GB en_PK zh_Hans_SG or_IN bs_BA ar_MA bo_IN sr_Latn_ME en_MT kln_KE dav_KE ee_TG sr_Latn_RS my_MM es_PA hi_IN bn_IN sr_Latn es_PR cgg_UG fr_GP haw_US ar_IQ gv_GB sv_SE fi_FI ar_SY pa_Arab_PK de_CH nl_NL km_KH lt_LT fr_GA mas_KE so_SO ii_CN uz_Cyrl_UZ asa_TZ sv_FI mt_MT en_MH ne_IN ps_AF yo_NG es_PY en_JM fr_CD es_419 fil_PH guz_KE he_IL kl_GL es_NI ur_IN ga_IE gl_ES mas_TZ zu_ZA om_KE ru_UA so_DJ uz_Cyrl en_AU ta_IN mfe_MU en_AS lg_UG xog_UG fr_TG uk_UA gsw_CH en_US
refresh boolean whether to force calling live carrier API. By default, we might return a fresh result from the cache
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
tracking_number string Tracking number of shipment required 567293923024
webhooks boolean whether to allow webhook functionality for this shipment


Successful Response
Field Possible Values Example
success object
message string Message describing the action was performed successfully Success!


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required carrier_no_shipment_found carrier_no_shipment_found
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: No shipment found with tracking number: 567293923024
Example Request / Response
{
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/cancel \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "cancel": {
        "shipping_account": "00000000000000",
        "carrier": "ups",
        "tracking_number": "1Z168R020399800319"
    }
}
url = "https://api.zenkraft.com/cancel"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "success": {
    "message": "The shipment has been canceled successfully"
  }
}

/pickup/availability POST

Find the time slots between the start_date and the end_date during which the carrier can pick up the specified shipments.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
pickup_availability object required
close_time string Reserved for future use 2021-06-04
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL PKR MMK TRY XCD NGN SLL MWK HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF CLP BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT AFN THB COP MDL GYD GIP DOP CUC HUF VND UAH SRD MYR
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
end_date string End of the range of dates to check required 2021-06-04
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU NP WF HK TL NE US US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
ready_time string Reserved for future use 2021-06-04
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU NP HK TL NE WF US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
start_date string Start of the range of dates to check required 2021-06-04
test boolean calls created with test = true will be directed to the carrier test servers
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
pickup_availability object
dates array
date string Pickup date 2021-06-04
earliest string The earliest time the shipments can be picked up 09:00
latest string The latest time the shipments can be picked up 18:00
debug boolean calls with debug=true will be logged
dim_units string Dimension units of the packages, inches or centimeters CM IN IN
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
weight_units string Weight units of the packages, pounds or kilograms KG LB LB


Error Response
Field Possible Values Example
error object
code string Standardized error code required shipping_account_wrong_carrier unexpected_exception wrong_api_key carrier_http_exception invalid_phone_number missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found carrier_unsupported_method schema_field_required ship_date_past carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-11-22",
        "end_date": "2026-11-22"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/pickup/availability \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-11-22",
        "end_date": "2026-11-22"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-11-22",
        "end_date": "2026-11-22"
    }
}
url = "https://api.zenkraft.com/pickup/availability"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
    "pickup_availability": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "service": "economy"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "weight_units": "LB",
        "start_date": "2026-11-22",
        "end_date": "2026-11-22",
        "dates": [
            {
                "date" : "2021-06-30",
                "earliest": "09:00",
                "latest": "18:00"
            },
            {
                "date" : "2021-07-01",
                "earliest": "09:00",
                "latest": "18:00"
            },
            {
                "date" : "2021-07-02",
                "earliest": "09:00",
                "latest": "15:00"
            }
        ]
    }
}

/pickup POST

The pickup endpoint allows you to schedule pickups for one or more shipments.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
pickup object required
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL MMK PKR TRY XCD NGN SLL HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN MYR IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT SRD AFN THB COP MDL GYD GIP DOP CUC HUF VND UAH MWK CLP
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU NP WF HK TL NE US US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
time object the date and time you want to create the pickup for. required
close_time string end of pickup time required 19:00
date string the date you want to create pickup for. required 2021-06-07
ready_time string start of pickup time required 12:30
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Successful Response
Field Possible Values Example
pickup object
confirmation_number string reference number of this pickup. It can be used to cancel the pickup if the carrier allows it 123456789
currency string LBP SEK TJS TVD WST BND AUD PYG CZK BBD PGK INR CVE SYP LYD SGD VEF VUV DKK GBP KES MVR OMR HKD SCR RSD HNL XPF KMF IQD CUP TND RON RWF KRW TWD NIO CRC AMD BTN UGX LSL PKR MMK TRY XCD NGN SLL MWK HTG ERN SBD ISK DJF AZN BHD BRL KYD GEL XDR AED BIF STN UZS ALL MGA SVC CAD KHR PAB MRU CNY GNF TZS SOS HRK KWD PHP FJD MKD LKR MXN IMP NZD ZWD NPR EGP MAD JOD BSD SDG SAR CDF LRD ETB GGP NOK EUR TMT JMD KZT SZL UYU SPL ILS BWP BMD QAR USD MZN ANG CHF KPW AWG FKP GHS TTD YER DZD ARS BGN NAD AOA XAF CLP BZD PLN IDR BDT GTQ IRR GMD ZMW KGS JPY BOB MOP SHP MUR TOP ZAR PEN LAK BAM JEP XOF RUB BYN MNT AFN THB COP MDL GYD GIP DOP CUC HUF VND UAH SRD MYR
debug boolean calls with debug=true will be logged
description string
dim_units string Dimension units of the packages, inches or centimeters required CM IN IN
id string internal pickup ID cf8a402288034fd9941dc1efe22b0680
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF NP HK TL NE US US
email string the email address of the recipient jrogers@example.com
location_type string description of the pickup location required front
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient required (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipments array required
packages array required
height number height of the package according to units specified under dim_units 5
length number length of the package according to units specified under dim_units. ususally the length needs to be the largest of length, width, height 11
value number value of the package according to currency specified 25
weight number weight of the package according to units specified under weight_units 4.2
width number width of the package according to units specified under dim_units 8.5
recipient object
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR US KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF HK TL NE NP US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
service string the service type fedex_ground
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers
time object the date and time you want to create the pickup for. required
close_time string end of pickup time required 19:00
date string the date you want to create pickup for. required 2021-06-07
ready_time string start of pickup time required 12:30
weight_units string Weight units of the packages, pounds or kilograms required KG LB LB


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method invalid_phone_number missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required ship_date_past carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message object Error message required FedEx API: The origin country code XX could not be found. Please check the country code.
Example Request / Response
{
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}
                curl --request POST \
--url https://api.zenkraft.com/pickup \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "pickup": {
        "carrier": "fedex",
        "debug": true,
        "dim_units": "IN",
        "location": {
            "city": "San Francisco",
            "company": "Test Company",
            "country": "US",
            "email": "test@example.com",
            "location_type": "business",
            "name": "Test Name",
            "phone": "+1 201-333-4444",
            "postal_code": "94105",
            "state": "NJ",
            "street1": "1 Market Street"
        },
        "shipments": [
            {
                "packages": [
                    {
                        "quantity": 1,
                        "weight": 3
                    }
                ],
                "recipient": {
                    "country": "US"
                },
                "service": "express_worldwide_p"
            }
        ],
        "shipping_account": 197299590,
        "test": true,
        "time": {
            "ready_time": "09:45",
            "close_time": "16:45",
            "date": "2021-05-20"
        },
        "weight_units": "LB"
    }
}
url = "https://api.zenkraft.com/pickup"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "pickup": {
    "confirmation_number": "123456789",
    "id": "cf8a402288034fd9941dc1efe22b0680",
    "carrier": "fedex",
    "shipping_account": "5190163571408896",
    "test": true,
    "debug": false,
    "description": "string",
    "currency": "USD",
    "dim_units": "IN",
    "weight_units": "LB",
    "location": {
      "name": "Jack O'Rogers",
      "company": "Burlington Textiles Corp of America",
      "street1": "525 S. ZENKRAFT Ave",
      "street2": "suite 120",
      "email": "jrogers@example.com",
      "phone": "(336) 222-7000",
      "city": "Burlington",
      "state": "NC",
      "postal_code": "27215",
      "country": "US",
      "location_type": "front"
    },
    "shipments": [
      {
        "recipient": {
          "name": "Jack O'Rogers",
          "company": "Burlington Textiles Corp of America",
          "street1": "525 S. ZENKRAFT Ave",
          "street2": "suite 120",
          "email": "jrogers@example.com",
          "phone": "(336) 222-7000",
          "city": "Burlington",
          "state": "NC",
          "postal_code": "27215",
          "country": "US"
        },
        "packages": [
          {
            "weight": 4.2,
            "value": 25,
            "length": 11,
            "width": 8.5,
            "height": 5
          }
        ],
        "service": "fedex_ground"
      }
    ],
    "time": {
      "close_time": "19:00",
      "ready_time": "12:30",
      "date": "2021-06-07"
    }
  }
}

/dopu POST

The dopu endpoint is used to retrieve the list of possible drop off locations nearby.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
dopu object required
debug boolean calls with debug=true will be logged
location object required
city string the city of the recipient required Burlington
company string the company name of the recipient Burlington Textiles Corp of America
country string required ZM AO CR DM ZW BH MD NA PM BG ID AD VE KP VI TR BD IR CA AM CD AS CF GT CL BR OM GB LI PT SE FI CO BF CY MU MY NO BJ TF VU KH SD WS GQ BA KW TV GN LR KR PS AF MA SA BW SC CG HR MZ GE KY MG SR CZ SS PW NL AW PA NR BB LA BV LC VN IO TZ MQ UG GM JM CC AR BT GI IL IT KN LY PL BM HM ZA EE PH GH LV SJ SY MF CU PK AE UM UY AG MM LB AQ AI BS SL TN IM TK RO AL MH SI IQ JP ET KI AT BE SX LT VC TT AX PY CX BO NG BY RU NF KG MX IN BQ SB SK VA GW YE LU ME UA ST GR MK SO EG FJ FR NZ YT CK MC HN BZ DJ BL MW CI LK HU GG DO CM TG GP TW GS NC TM UZ BN MT PF GL SZ GD MN MP FO TH DZ MS TJ CN KM ES SV RE LS VG HT TC KE EH EC QA MO CV RW AU ER SM MR NI JO ML TO MV PR CW JE FK IE IS GY DE PG CH SG DK GF KZ NU TD PN RS GA PE BI SN AZ SH FM GU WF NP HK TL NE US US
email string the email address of the recipient jrogers@example.com
name string the name of the recipient required Jack O'Rogers
phone string the phone number of the recipient (336) 222-7000
postal_code string the postal code / zip number of the recipient. Specific format depends on the country 27215
state string the state of the recipient NC
street1 string the first line of the street address of the recipient required 525 S. ZENKRAFT Ave
street2 string the second line of the street address of the recipient suite 120
street3 string the third line of the street address of the recipient suite 120
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers


Successful Response
Field Possible Values Example
locations array
city string Burlington
country string AD AE AF AG AI AL AM AO AQ AR AS AT AU AW AX AZ BA BB BD BE BF BG BH BI BJ BL BM BN BO BQ BR BS BT BV BW BY BZ CA CC CD CF CG CH CI CK CL CM CN CO CR CU CV CW CX CY CZ DE DJ DK DM DO DZ EC EE EG EH ER ES ET FI FJ FK FM FO FR GA GB GD GE GF GG GH GI GL GM GN GP GQ GR GS GT GU GW GY HK HM HN HR HT HU ID IE IL IM IN IO IQ IR IS IT JE JM JO JP KE KG KH KI KM KN KP KR KW KY KZ LA LB LC LI LK LR LS LT LU LV LY MA MC MD ME MF MG MH MK ML MM MN MO MP MQ MR MS MT MU MV MW MX MY MZ NA NC NE NF NG NI NL NO NP NR NU NZ OM PA PE PF PG PH PK PL PM PN PR PS PT PW PY QA RE RO RS RU RW SA SB SC SD SE SG SH SI SJ SK SL SM SN SO SR SS ST SV SX SY SZ TC TD TF TG TH TJ TK TL TM TN TO TR TT TV TW TZ UA UG UM US UY UZ VA VC VE VG VI VN VU WF WS YE YT ZA ZM ZW US
distance number how far is it from the location described in the request to this pickup location 1.3
distance_units string km
lat string latitude -79.43575121732864
lng string longitude 36.089788917096016
location_code string carrier assigned location ID A4415567
location_name string name of the business/post office United States Postal Service
location_type string the type of this pickup location post_office
postal_code string 27215
state string NC
street1 string 405 Maple Ave


Error Response
Field Possible Values Example
error object
code string Standardized error code required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required carrier_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message string Error message required FedEx API: Postal code specified is not in the correct format
Example Request / Response
{
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}
                curl --request POST \
--url https://api.zenkraft.com/dopu \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "dopu": {
        "carrier": "fedex",
        "location": {
            "city": "San Diego",
            "country": "US",
            "postal_code": "92131",
            "state": "CA",
            "street1": "1 Market Street"
        },
        "shipping_account": "673603996",
        "test": true
    }
}
url = "https://api.zenkraft.com/dopu"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "locations": [
    {
      "location_type": "post_office",
      "distance": 1.3,
      "distance_units": "km",
      "location_name": "United States Postal Service",
      "location_code": "A4415567",
      "city": "Burlington",
      "street1": "405 Maple Ave",
      "state": "NC",
      "postal_code": "27215",
      "country": "US",
      "lng": "36.089788917096016",
      "lat": "-79.43575121732864"
    }
  ]
}

/manifest POST

Manifesting allows you to notify the carrier that your shipments are ready for shipping/pickup.

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
manifest object required
debug boolean calls with debug=true will be logged
shipping_account string Shipping account number required 5190163571408896
test boolean calls created with test = true will be directed to the carrier test servers


Successful Response
Field Possible Values Example
manifest object
costs object Additional information about packages
base_charge number gross amount 100
discounts number the cost of discounts applied
net_charge number net amount 80
surcharges number additional fees
taxes number the cost of taxes 20
id string carrier ID of this manifest which can be used in GET on /manifest/<manifest_id> 963681622636173689
shipping_documents object Additional information about packages
description string description of this customs item required Manifest
document string base64 document contents required
document_type string file format of the document required PDF


Error Response
Field Possible Values Example
error object
code string Standardized error code. If the code equals `carrier_large_manifest` you might retrieve manifest_id from the error detail required unexpected_exception wrong_api_key carrier_http_exception carrier_unsupported_method missing_api_key carrier_throttling carrier_timeout schema_validation_error carrier_failed_connection carrier_large_manifest carrier_authentication carrier_exception shipping_account_not_found shipping_account_wrong_carrier schema_field_required carrier_large_manifest
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required 963681622636173689
message string Error message required The manifest is too large and it's going to take around 15 to generate. Retry again later please
Example Request / Response
{
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}
                curl --request POST \
--url https://api.zenkraft.com/manifest \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX' \
--data '{
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = {
    "manifest": {
        "carrier": "fedex",
        "debug": true,
        "shipping_account": 40910738,
        "test": true,
        "tracking_numbers": [
            "33GKB500127801000961509",
            "111JD575508301000961502",
            "111JD575511501000961500"
        ]
    }
}
url = "https://api.zenkraft.com/manifest"

response = requests.request(url=url, method='POST', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "manifest": {
    "id": "963681622636173689",
    "shipping_documents": [{
      "description": "Manifest",
      "document_type": "PDF",
      "document": "string"
    }],
    "costs": {
      "base_charge": 100,
      "net_charge": 80,
      "taxes": 20,
      "surcharges": 0,
      "discounts": 0
    }
  }
}

/manifest GET

This endpoint allows you to retrieve previously created manifests.

Successful Response
Field Possible Values Example
manifests array
carrier string the carrier name fedex
created string when was this object created 2021-06-02T07:22:43.000
id string carrier ID of this manifest which can be used in GET on /manifest/<manifest_id> 963681622636173689
shipping_account string Shipping account number 5190163571408896


Error Response
Field Possible Values Example
error object
code string Standardized error code required missing_api_key wrong_api_key shipping_account_not_found shipping_account_wrong_carrier schema_validation_error schema_field_required unexpected_exception
detail string This field can contain additional information about the error. This field is not meant to be shown to the end-user required
message string Error message required Missing zkkey HTTP header containing your Zenkraft API key
Example Request / Response
https://api.zenkraft.com/manifest
                curl --request GET \
--url https://api.zenkraft.com/manifest \
--header 'content-type: application/json' \
--header 'zkkey: XXXXXXXXXXXXXXXXXXXXXXX'
            

import requests

headers = {
"zkkey": "XXXXXXXXXXXXXXXXXXXXXXX"
}

payload = None
url = "https://api.zenkraft.com/manifest"

response = requests.request(url=url, method='GET', json=payload, headers=headers)

print(response.json())
            
                
            
{
  "manifests": [
    {
      "carrier": "fedex",
      "created": "2021-06-02T07:22:43.000",
      "id": "963681622636173689",
      "shipping_account": "5190163571408896"
    }
  ]
}

/webhook POST

Webhooks provide you with a real-time view of your shipments.

1. Create a webhook configuration

In order to start using webhooks, you need to create a webhook configuration. You can find an example payload on the right side.

2. Receive a webhook

Now we will start sending tracking event updates as POST requests to your chosen address. The request will be formatted the same way as our track response

3. Verify a webhook

Webhooks can be verified by calculating a digital signature. Each webhook request includes a base64-encoded X-Zenkraft-Hmac-SHA256 header, which is generated using your API key along with the data sent in the request. Once you verify this signature, you can be sure the request came from us and you can continue your processing.

4. Response to a webhook

Your endpoint acknowledges that it received data by sending a 200 response. Any response outside of 200-range is considered an error. On our side, we have set a 5 second timeout. Any errors will be retried in a staggered manner over the course of the day.

Testing a Webhook

To test a webhook, run a local server or use a publicly available service such as Beeceptor. If you decide to run a server locally, then you need to make it publicly available using a service such as Pagekite or ngrok. The following URLs can't be endpoints for a webhook:

  • Localhost
  • Any URL ending in the word "internal"
  • Domains like www.example.com
  • Zenkraft domains such as api.zenkraft.com

The following example includes all of the request parameters that Zenkraft supports. To see the required and optional parameters for a specific carrier, select from the Choose Carrier dropdown in the menu.

POST Request Parameters
Field Possible Values Example
webhook object required
api_version string The webhook version. Used for future compatibility v1
callback string URL of the receiving endpoint required https://webhook.site/3a788dd3-bd7c-44a8-bae0-297e3b68b508
debug boolean calls with debug=true will be logged
description string Webhook description
events array Events to receive. If left empty, it's assumed you want to receive all the events shipment.picked_up shipment.exception return.exception return.delivered return.picked_up return.in_transit shipment.checked_in shipment.in_transit shipment.driver_assigned shipment.shipment_voided shipment.delivered return.shipment_voided return.creation_pending return.checked_in return.driver_assigned return.out_for_delivery shipment.created shipment.out_for_delivery shipment.creation_pending return.created shipment.delivered
format string Currently only JSON is supported. Used for future compatibility json
headers array Headers that will be sent to the webhook callback.
name string Authorization
value string api_key
name string Webhook name
shipping_account_id integer 123
trigger_mode string checkpoint stage


Successful Response
Field Possible Values Example
webhook object
api_version string The webhook version. Used for future compatibility v1
callback string URL of the receiving endpoint required https://webhook.site/3a788dd3-bd7c-44a8-bae0-297e3b68b508
debug boolean calls with debug=true will be logged
description string Webhook description
[...]
